#define	_POSIX_SOURCE	1
/*
 * Two-Way(R) IPC client module for twd.
 * dannyb@bga.com	10/27/96
*/
#include <string.h>
#include <unistd.h>

#include "client.h"

/* global variables */
long serverpid = -1;
long serverqid = -1;

int x10check(void) {
  return(peek_qid(serverqid, (long)getpid()));
}

int x10getqid(void) {
  return rdpidfile(PIDFILE, &serverpid, &serverqid);
}

int x10send(struct x10msg *m) {
  m->from = (long)getpid();
  m->to = serverpid;
  return send_msg(serverqid, m);
}

int x10rec(struct x10msg *m) {
  return rec_msg(serverqid, (long)getpid(), m);
}

void x10unregister(void) {
  struct x10msg m;
  m.to = serverpid;
  m.from = (long)getpid();
  strcpy(m.func, "-");
  (void)send_msg(serverqid, &m);
  return;
}

int x10register(void) {
  struct x10msg m;
  m.to = serverpid;
  m.from = (long)getpid();
  strcpy(m.func, "+");
  if (send_msg(serverqid, &m) == -1) return -1;
  if(rec_msg(serverqid, (long)getpid(), &m) < 0) return -1;
  if (strcmp(m.func, "+") == 0)	return 0;
  else return -1;
}

