/* 
 * IPC routines common to server and client modules
 * dannyb@bga.com	10/30/96
*/
#include <errno.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <signal.h>

#include "clientserver.h"

#define	TRUE	1
#define	FALSE	0



/********* Server-only IPC routines ************/
long create_queue(int perms) {
  return (long)msgget(IPC_PRIVATE, perms);
}

void delete_queue(long qid) {
  return (void)msgctl((key_t)qid, IPC_RMID, NULL);
}


/*********   Common IPC routines   ************/
int peek_qid(long qid, long type) {
  struct msgbuf m;
  (void)msgrcv((key_t)qid, &m, 0, type, IPC_NOWAIT);
  if (errno == E2BIG)   /* message is waiting for us */
        return TRUE;
  if (errno == ENOMSG)  /* no message in queue */
        return FALSE;
  return -1;		/* error */
}


int send_msg(long qid, struct x10msg *m) {
  return msgsnd((key_t)qid, (struct msgbuf *)m,
  	sizeof(struct x10msg) - sizeof(long), 0);
}


int rec_msg(long qid, long to, struct x10msg *m) {
  return msgrcv((key_t)qid, (struct msgbuf *)m,
		(sizeof(struct x10msg) - sizeof(long)),
		to, MSG_NOERROR);
}


/************** Pidfile routines *****************/

int rdpidfile(char *filename, long *pid, long *qid) {
  FILE *fd;
  int result;
  fd = fopen(filename, "r");
  if (fd == NULL)
        return -1;
  result = fscanf(fd, "%li %li\n", pid, qid);
  fclose(fd);
  if ( (result == 2) && (kill(*pid, 0) == 0) )
        return 0;
  else
        return -1;
}

int mkpidfile(char *filename, long pid, long qid) {
  FILE *fd;
  fd = fopen(PIDFILE, "w+");
  if (fd == NULL)
        return -1;
  fprintf(fd, "%li %li\n", pid, qid);
  fclose(fd);
  return 0;
}

