#define _POSIX_SOURCE   1
/*
 * recx.c
 * Sample client app for 'twd' server. prints incoming X10 codes to
 * stdout.
 *
 * dannyb@bga.com 10/30/96
 *
 * Copyright (c) 1996 Daniel R. Barrett.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
*/
#include <stdio.h>
#include <getopt.h>
#include <signal.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include "client.h"


int main(int argc, char **argv) {
  struct x10msg m;
  int i;

  if (x10getqid() == -1) {
	perror("error connecting to server\n");
	exit(1);
  }
  if (x10register() == -1) {
	perror("server is maxed out");
	exit(1);
  }
  while(1) {
	if (x10rec(&m) < 0) {
		perror("IPC error");
		exit(1);
	}
	printf("%c ", m.house);
	if (m.modules == 0) {
		printf("0 ");
	} else {
		for(i=0; i<16; i++) {
			if (m.modules & (1<<i))
				printf("%i ", i+1);
		}
	}
	printf("%2s\n", m.func);
  }
  exit(0);	/* Never happens */
}

/* NOTE:
 * A correct receive program should have an exit handler that calls
 * x10unregister() when the program dies. The server attempts to
 * signal the client before enquing a message and if the kill() call
 * fails it removes the client from it's list so this is not strictly
 * necessary.
*/
